<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-comment">-- |</span><span>
</span><span id="line-2"></span><span class="hs-comment">-- Module      : RandomizeSentence</span><span>
</span><span id="line-3"></span><span class="hs-comment">--</span><span>
</span><span id="line-4"></span><span class="hs-comment">-- This module contains all the functions that generate random objects and work</span><span>
</span><span id="line-5"></span><span class="hs-comment">-- with the 'SentenceState' in the State monad.</span><span>
</span><span id="line-6"></span><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Exercises.RandomizeSentence</span><span>
</span><span id="line-7"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomPersonNumberThirdSingBias"><span class="hs-identifier">randomPersonNumberThirdSingBias</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-8"></span><span>    </span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomPersonNumber"><span class="hs-identifier">randomPersonNumber</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-9"></span><span>    </span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomNumber"><span class="hs-identifier">randomNumber</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-10"></span><span>    </span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomDeterminer"><span class="hs-identifier">randomDeterminer</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-11"></span><span>    </span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomDeterminerDegree"><span class="hs-identifier">randomDeterminerDegree</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-12"></span><span>    </span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomizeSentenceType"><span class="hs-identifier">randomizeSentenceType</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-13"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-14"></span><span class="hs-keyword">where</span><span>
</span><span id="line-15"></span><span>
</span><span id="line-16"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="BasicData.html"><span class="hs-identifier">BasicData</span></a></span><span>
</span><span id="line-17"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.State</span></span><span>
</span><span id="line-18"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.List</span></span><span>
</span><span id="line-19"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.html"><span class="hs-identifier">Features</span></a></span><span>
</span><span id="line-20"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html"><span class="hs-identifier">Syntax.ProtoSentence</span></a></span><span>
</span><span id="line-21"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">System.Random</span></span><span>
</span><span id="line-22"></span><span>
</span><span id="line-23"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomRange"><span class="hs-identifier hs-type">randomRange</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span class="hs-special">)</span><span>
</span><span id="line-24"></span><span id="randomRange"><span class="annot"><span class="annottext">randomRange :: (Int, Int)
</span><a href="Exercises.RandomizeSentence.html#randomRange"><span class="hs-identifier hs-var hs-var">randomRange</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">0</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">100</span></span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span>
</span><span id="line-26"></span><span class="hs-comment">-- The Haskell type State describes functions that consume a state and</span><span>
</span><span id="line-27"></span><span class="hs-comment">-- produce both a result and an updated state, which are given back in a tuple.</span><span>
</span><span id="line-28"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomizeSentenceWith"><span class="hs-identifier hs-type">randomizeSentenceWith</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-29"></span><span>  </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-30"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-31"></span><span id="randomizeSentenceWith"><span class="annot"><span class="annottext">randomizeSentenceWith :: (Int -&gt; ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.RandomizeSentence.html#randomizeSentenceWith"><span class="hs-identifier hs-var hs-var">randomizeSentenceWith</span></a></span></span><span> </span><span id="local-6989586621679082935"><span class="annot"><span class="annottext">Int -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="#local-6989586621679082935"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((StdGen, ProtoSentence)
 -&gt; (ProtoSentence, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) ProtoSentence
forall s (m :: * -&gt; *) a. MonadState s m =&gt; (s -&gt; (a, s)) -&gt; m a
</span><span class="hs-identifier hs-var">state</span></span><span> </span><span class="annot"><span class="annottext">(((StdGen, ProtoSentence)
  -&gt; (ProtoSentence, (StdGen, ProtoSentence)))
 -&gt; State (StdGen, ProtoSentence) ProtoSentence)
-&gt; ((StdGen, ProtoSentence)
    -&gt; (ProtoSentence, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) ProtoSentence
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679082933"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082933"><span class="hs-identifier hs-var">gen</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082932"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082932"><span class="hs-identifier hs-var">proto</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-32"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679082931"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082931"><span class="hs-identifier hs-var">randomNum</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082930"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082930"><span class="hs-identifier hs-var">newGen</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Int, Int) -&gt; StdGen -&gt; (Int, StdGen)
forall a g. (Random a, RandomGen g) =&gt; (a, a) -&gt; g -&gt; (a, g)
</span><span class="hs-identifier hs-var">randomR</span></span><span> </span><span class="annot"><span class="annottext">(Int, Int)
</span><a href="Exercises.RandomizeSentence.html#randomRange"><span class="hs-identifier hs-var">randomRange</span></a></span><span> </span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082933"><span class="hs-identifier hs-var">gen</span></a></span><span>
</span><span id="line-33"></span><span>      </span><span id="local-6989586621679082928"><span class="annot"><span class="annottext">newSent :: ProtoSentence
</span><a href="#local-6989586621679082928"><span class="hs-identifier hs-var hs-var">newSent</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Int -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="#local-6989586621679082935"><span class="hs-identifier hs-var">f</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082931"><span class="hs-identifier hs-var">randomNum</span></a></span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082932"><span class="hs-identifier hs-var">proto</span></a></span><span>
</span><span id="line-34"></span><span>   </span><span class="hs-keyword">in</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082928"><span class="hs-identifier hs-var">newSent</span></a></span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082930"><span class="hs-identifier hs-var">newGen</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082928"><span class="hs-identifier hs-var">newSent</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-35"></span><span>
</span><span id="line-36"></span><span class="hs-comment">-- | Generatos an 'NF' with a random 'Person' and 'Number' and absolutive 'Case'</span><span>
</span><span id="line-37"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomPersonNumber"><span class="hs-identifier hs-type">randomPersonNumber</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span>
</span><span id="line-38"></span><span id="randomPersonNumber"><span class="annot"><span class="annottext">randomPersonNumber :: State (StdGen, ProtoSentence) NF
</span><a href="Exercises.RandomizeSentence.html#randomPersonNumber"><span class="hs-identifier hs-var hs-var">randomPersonNumber</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((StdGen, ProtoSentence) -&gt; (NF, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) NF
forall s (m :: * -&gt; *) a. MonadState s m =&gt; (s -&gt; (a, s)) -&gt; m a
</span><span class="hs-identifier hs-var">state</span></span><span> </span><span class="annot"><span class="annottext">(((StdGen, ProtoSentence) -&gt; (NF, (StdGen, ProtoSentence)))
 -&gt; State (StdGen, ProtoSentence) NF)
-&gt; ((StdGen, ProtoSentence) -&gt; (NF, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) NF
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679082927"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082927"><span class="hs-identifier hs-var">gen</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082926"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082926"><span class="hs-identifier hs-var">proto</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-39"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679082925"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082925"><span class="hs-identifier hs-var">randomNum</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082924"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082924"><span class="hs-identifier hs-var">newGen</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Int, Int) -&gt; StdGen -&gt; (Int, StdGen)
forall a g. (Random a, RandomGen g) =&gt; (a, a) -&gt; g -&gt; (a, g)
</span><span class="hs-identifier hs-var">randomR</span></span><span> </span><span class="annot"><span class="annottext">(Int, Int)
</span><a href="Exercises.RandomizeSentence.html#randomRange"><span class="hs-identifier hs-var">randomRange</span></a></span><span> </span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082927"><span class="hs-identifier hs-var">gen</span></a></span><span>
</span><span id="line-40"></span><span>      </span><span class="hs-special">(</span><span id="local-6989586621679082923"><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679082923"><span class="hs-identifier hs-var">p</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082922"><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679082922"><span class="hs-identifier hs-var">n</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[(Person, Number)]
</span><a href="Exercises.RandomizeSentence.html#personNumberOptions"><span class="hs-identifier hs-var">personNumberOptions</span></a></span><span> </span><span class="annot"><span class="annottext">[(Person, Number)] -&gt; Int -&gt; (Person, Number)
forall a. [a] -&gt; Int -&gt; a
</span><span class="hs-operator hs-var">!!</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082925"><span class="hs-identifier hs-var">randomNum</span></a></span><span> </span><span class="annot"><span class="annottext">Int -&gt; Int -&gt; Int
forall a. Integral a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">`mod`</span></span><span> </span><span class="annot"><span class="annottext">[(Person, Number)] -&gt; Int
forall (t :: * -&gt; *) a. Foldable t =&gt; t a -&gt; Int
</span><span class="hs-identifier hs-var">length</span></span><span> </span><span class="annot"><span class="annottext">[(Person, Number)]
</span><a href="Exercises.RandomizeSentence.html#personNumberOptions"><span class="hs-identifier hs-var">personNumberOptions</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-41"></span><span>   </span><span class="hs-keyword">in</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF
</span><a href="BasicData.html#norArgF"><span class="hs-identifier hs-var">norArgF</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">person :: Person
</span><a href="Features.Nominal.html#person"><span class="hs-identifier hs-var">person</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679082923"><span class="hs-identifier hs-var">p</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">number :: Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var">number</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679082922"><span class="hs-identifier hs-var">n</span></a></span><span class="hs-special">}</span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082924"><span class="hs-identifier hs-var">newGen</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082926"><span class="hs-identifier hs-var">proto</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-42"></span><span>
</span><span id="line-43"></span><span class="hs-comment">-- | Generates an 'NF' with a random 'Person' and 'Number' and absolutive 'Case'.</span><span>
</span><span id="line-44"></span><span class="hs-comment">-- The probability of (Third, Singular) is higher than the rest of the combinations.</span><span>
</span><span id="line-45"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomPersonNumberThirdSingBias"><span class="hs-identifier hs-type">randomPersonNumberThirdSingBias</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span>
</span><span id="line-46"></span><span id="randomPersonNumberThirdSingBias"><span class="annot"><span class="annottext">randomPersonNumberThirdSingBias :: State (StdGen, ProtoSentence) NF
</span><a href="Exercises.RandomizeSentence.html#randomPersonNumberThirdSingBias"><span class="hs-identifier hs-var hs-var">randomPersonNumberThirdSingBias</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((StdGen, ProtoSentence) -&gt; (NF, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) NF
forall s (m :: * -&gt; *) a. MonadState s m =&gt; (s -&gt; (a, s)) -&gt; m a
</span><span class="hs-identifier hs-var">state</span></span><span> </span><span class="annot"><span class="annottext">(((StdGen, ProtoSentence) -&gt; (NF, (StdGen, ProtoSentence)))
 -&gt; State (StdGen, ProtoSentence) NF)
-&gt; ((StdGen, ProtoSentence) -&gt; (NF, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) NF
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679082914"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082914"><span class="hs-identifier hs-var">gen</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082913"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082913"><span class="hs-identifier hs-var">proto</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-47"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679082912"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082912"><span class="hs-identifier hs-var">randomNum</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082911"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082911"><span class="hs-identifier hs-var">newGen</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Int, Int) -&gt; StdGen -&gt; (Int, StdGen)
forall a g. (Random a, RandomGen g) =&gt; (a, a) -&gt; g -&gt; (a, g)
</span><span class="hs-identifier hs-var">randomR</span></span><span> </span><span class="annot"><span class="annottext">(Int, Int)
</span><a href="Exercises.RandomizeSentence.html#randomRange"><span class="hs-identifier hs-var">randomRange</span></a></span><span> </span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082914"><span class="hs-identifier hs-var">gen</span></a></span><span>
</span><span id="line-48"></span><span>      </span><span class="hs-special">(</span><span id="local-6989586621679082910"><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679082910"><span class="hs-identifier hs-var">p</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082909"><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679082909"><span class="hs-identifier hs-var">n</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[(Person, Number)]
</span><a href="Exercises.RandomizeSentence.html#personNumberOptionsThirdSingBias"><span class="hs-identifier hs-var">personNumberOptionsThirdSingBias</span></a></span><span> </span><span class="annot"><span class="annottext">[(Person, Number)] -&gt; Int -&gt; (Person, Number)
forall a. [a] -&gt; Int -&gt; a
</span><span class="hs-operator hs-var">!!</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082912"><span class="hs-identifier hs-var">randomNum</span></a></span><span> </span><span class="annot"><span class="annottext">Int -&gt; Int -&gt; Int
forall a. Integral a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">`mod`</span></span><span> </span><span class="annot"><span class="annottext">[(Person, Number)] -&gt; Int
forall (t :: * -&gt; *) a. Foldable t =&gt; t a -&gt; Int
</span><span class="hs-identifier hs-var">length</span></span><span> </span><span class="annot"><span class="annottext">[(Person, Number)]
</span><a href="Exercises.RandomizeSentence.html#personNumberOptions"><span class="hs-identifier hs-var">personNumberOptions</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-49"></span><span>   </span><span class="hs-keyword">in</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF
</span><a href="BasicData.html#norArgF"><span class="hs-identifier hs-var">norArgF</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">person :: Person
</span><a href="Features.Nominal.html#person"><span class="hs-identifier hs-var">person</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679082910"><span class="hs-identifier hs-var">p</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">number :: Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var">number</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679082909"><span class="hs-identifier hs-var">n</span></a></span><span class="hs-special">}</span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082911"><span class="hs-identifier hs-var">newGen</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082913"><span class="hs-identifier hs-var">proto</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-50"></span><span>
</span><span id="line-51"></span><span class="hs-comment">-- | Produces a random grammatical 'Number': Singular or Plural</span><span>
</span><span id="line-52"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomNumber"><span class="hs-identifier hs-type">randomNumber</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span><span>
</span><span id="line-53"></span><span id="randomNumber"><span class="annot"><span class="annottext">randomNumber :: State (StdGen, ProtoSentence) Number
</span><a href="Exercises.RandomizeSentence.html#randomNumber"><span class="hs-identifier hs-var hs-var">randomNumber</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((StdGen, ProtoSentence) -&gt; (Number, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) Number
forall s (m :: * -&gt; *) a. MonadState s m =&gt; (s -&gt; (a, s)) -&gt; m a
</span><span class="hs-identifier hs-var">state</span></span><span> </span><span class="annot"><span class="annottext">(((StdGen, ProtoSentence) -&gt; (Number, (StdGen, ProtoSentence)))
 -&gt; State (StdGen, ProtoSentence) Number)
-&gt; ((StdGen, ProtoSentence) -&gt; (Number, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) Number
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679082907"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082907"><span class="hs-identifier hs-var">gen</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082906"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082906"><span class="hs-identifier hs-var">proto</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-54"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679082905"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082905"><span class="hs-identifier hs-var">randomNum</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082904"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082904"><span class="hs-identifier hs-var">newGen</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Int, Int) -&gt; StdGen -&gt; (Int, StdGen)
forall a g. (Random a, RandomGen g) =&gt; (a, a) -&gt; g -&gt; (a, g)
</span><span class="hs-identifier hs-var">randomR</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">0</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">1</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082907"><span class="hs-identifier hs-var">gen</span></a></span><span>
</span><span id="line-55"></span><span>      </span><span id="local-6989586621679082903"><span class="annot"><span class="annottext">num :: Number
</span><a href="#local-6989586621679082903"><span class="hs-identifier hs-var hs-var">num</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Plural"><span class="hs-identifier hs-var">Plural</span></a></span><span class="hs-special">]</span><span> </span><span class="annot"><span class="annottext">[Number] -&gt; Int -&gt; Number
forall a. [a] -&gt; Int -&gt; a
</span><span class="hs-operator hs-var">!!</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082905"><span class="hs-identifier hs-var">randomNum</span></a></span><span>
</span><span id="line-56"></span><span>   </span><span class="hs-keyword">in</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679082903"><span class="hs-identifier hs-var">num</span></a></span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082904"><span class="hs-identifier hs-var">newGen</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082906"><span class="hs-identifier hs-var">proto</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-57"></span><span>
</span><span id="line-58"></span><span class="hs-comment">-- | Produces a random 'Determiner'</span><span>
</span><span id="line-59"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomDeterminer"><span class="hs-identifier hs-type">randomDeterminer</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Features.Nominal.html#Determiner"><span class="hs-identifier hs-type">Determiner</span></a></span><span>
</span><span id="line-60"></span><span id="randomDeterminer"><span class="annot"><span class="annottext">randomDeterminer :: State (StdGen, ProtoSentence) Determiner
</span><a href="Exercises.RandomizeSentence.html#randomDeterminer"><span class="hs-identifier hs-var hs-var">randomDeterminer</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((StdGen, ProtoSentence) -&gt; (Determiner, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) Determiner
forall s (m :: * -&gt; *) a. MonadState s m =&gt; (s -&gt; (a, s)) -&gt; m a
</span><span class="hs-identifier hs-var">state</span></span><span> </span><span class="annot"><span class="annottext">(((StdGen, ProtoSentence) -&gt; (Determiner, (StdGen, ProtoSentence)))
 -&gt; State (StdGen, ProtoSentence) Determiner)
-&gt; ((StdGen, ProtoSentence)
    -&gt; (Determiner, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) Determiner
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679082900"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082900"><span class="hs-identifier hs-var">gen</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082899"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082899"><span class="hs-identifier hs-var">proto</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-61"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679082898"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082898"><span class="hs-identifier hs-var">randomNum</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082897"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082897"><span class="hs-identifier hs-var">newGen</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Int, Int) -&gt; StdGen -&gt; (Int, StdGen)
forall a g. (Random a, RandomGen g) =&gt; (a, a) -&gt; g -&gt; (a, g)
</span><span class="hs-identifier hs-var">randomR</span></span><span> </span><span class="annot"><span class="annottext">(Int, Int)
</span><a href="Exercises.RandomizeSentence.html#randomRange"><span class="hs-identifier hs-var">randomRange</span></a></span><span> </span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082900"><span class="hs-identifier hs-var">gen</span></a></span><span>
</span><span id="line-62"></span><span>      </span><span id="local-6989586621679082896"><span class="annot"><span class="annottext">det :: Determiner
</span><a href="#local-6989586621679082896"><span class="hs-identifier hs-var hs-var">det</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Determiner]
</span><a href="Exercises.RandomizeSentence.html#determinerOptions"><span class="hs-identifier hs-var">determinerOptions</span></a></span><span> </span><span class="annot"><span class="annottext">[Determiner] -&gt; Int -&gt; Determiner
forall a. [a] -&gt; Int -&gt; a
</span><span class="hs-operator hs-var">!!</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082898"><span class="hs-identifier hs-var">randomNum</span></a></span><span> </span><span class="annot"><span class="annottext">Int -&gt; Int -&gt; Int
forall a. Integral a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">`mod`</span></span><span> </span><span class="annot"><span class="annottext">[Determiner] -&gt; Int
forall (t :: * -&gt; *) a. Foldable t =&gt; t a -&gt; Int
</span><span class="hs-identifier hs-var">length</span></span><span> </span><span class="annot"><span class="annottext">[Determiner]
</span><a href="Exercises.RandomizeSentence.html#determinerOptions"><span class="hs-identifier hs-var">determinerOptions</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-63"></span><span>   </span><span class="hs-keyword">in</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Determiner
</span><a href="#local-6989586621679082896"><span class="hs-identifier hs-var">det</span></a></span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082897"><span class="hs-identifier hs-var">newGen</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082899"><span class="hs-identifier hs-var">proto</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-64"></span><span>
</span><span id="line-65"></span><span class="hs-comment">-- | Produces a random determiner 'Distance' degree</span><span>
</span><span id="line-66"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomDeterminerDegree"><span class="hs-identifier hs-type">randomDeterminerDegree</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Features.Adverbial.html#Distance"><span class="hs-identifier hs-type">Distance</span></a></span><span>
</span><span id="line-67"></span><span id="randomDeterminerDegree"><span class="annot"><span class="annottext">randomDeterminerDegree :: State (StdGen, ProtoSentence) Distance
</span><a href="Exercises.RandomizeSentence.html#randomDeterminerDegree"><span class="hs-identifier hs-var hs-var">randomDeterminerDegree</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((StdGen, ProtoSentence) -&gt; (Distance, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) Distance
forall s (m :: * -&gt; *) a. MonadState s m =&gt; (s -&gt; (a, s)) -&gt; m a
</span><span class="hs-identifier hs-var">state</span></span><span> </span><span class="annot"><span class="annottext">(((StdGen, ProtoSentence) -&gt; (Distance, (StdGen, ProtoSentence)))
 -&gt; State (StdGen, ProtoSentence) Distance)
-&gt; ((StdGen, ProtoSentence) -&gt; (Distance, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) Distance
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679082894"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082894"><span class="hs-identifier hs-var">gen</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082893"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082893"><span class="hs-identifier hs-var">proto</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-68"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679082892"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082892"><span class="hs-identifier hs-var">randomNum</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082891"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082891"><span class="hs-identifier hs-var">newGen</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Int, Int) -&gt; StdGen -&gt; (Int, StdGen)
forall a g. (Random a, RandomGen g) =&gt; (a, a) -&gt; g -&gt; (a, g)
</span><span class="hs-identifier hs-var">randomR</span></span><span> </span><span class="annot"><span class="annottext">(Int, Int)
</span><a href="Exercises.RandomizeSentence.html#randomRange"><span class="hs-identifier hs-var">randomRange</span></a></span><span> </span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082894"><span class="hs-identifier hs-var">gen</span></a></span><span>
</span><span id="line-69"></span><span>      </span><span id="local-6989586621679082890"><span class="annot"><span class="annottext">deg :: Distance
</span><a href="#local-6989586621679082890"><span class="hs-identifier hs-var hs-var">deg</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Distance]
</span><a href="Exercises.RandomizeSentence.html#determinerDegreeOptions"><span class="hs-identifier hs-var">determinerDegreeOptions</span></a></span><span> </span><span class="annot"><span class="annottext">[Distance] -&gt; Int -&gt; Distance
forall a. [a] -&gt; Int -&gt; a
</span><span class="hs-operator hs-var">!!</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082892"><span class="hs-identifier hs-var">randomNum</span></a></span><span> </span><span class="annot"><span class="annottext">Int -&gt; Int -&gt; Int
forall a. Integral a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">`mod`</span></span><span> </span><span class="annot"><span class="annottext">[Distance] -&gt; Int
forall (t :: * -&gt; *) a. Foldable t =&gt; t a -&gt; Int
</span><span class="hs-identifier hs-var">length</span></span><span> </span><span class="annot"><span class="annottext">[Distance]
</span><a href="Exercises.RandomizeSentence.html#determinerDegreeOptions"><span class="hs-identifier hs-var">determinerDegreeOptions</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-70"></span><span>   </span><span class="hs-keyword">in</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Distance
</span><a href="#local-6989586621679082890"><span class="hs-identifier hs-var">deg</span></a></span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679082891"><span class="hs-identifier hs-var">newGen</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082893"><span class="hs-identifier hs-var">proto</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-71"></span><span>
</span><span id="line-72"></span><span class="hs-comment">-- | Randomizes the type of the 'ProtoSentence' contained in the 'SentenceState'</span><span>
</span><span id="line-73"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomizeSentenceType"><span class="hs-identifier hs-type">randomizeSentenceType</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-74"></span><span id="randomizeSentenceType"><span class="annot"><span class="annottext">randomizeSentenceType :: State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.RandomizeSentence.html#randomizeSentenceType"><span class="hs-identifier hs-var hs-var">randomizeSentenceType</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Int -&gt; ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.RandomizeSentence.html#randomizeSentenceWith"><span class="hs-identifier hs-var">randomizeSentenceWith</span></a></span><span> </span><span class="annot"><span class="annottext">Int -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.RandomizeSentence.html#randomSentenceType"><span class="hs-identifier hs-var">randomSentenceType</span></a></span><span>
</span><span id="line-75"></span><span>
</span><span id="line-76"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-77"></span><span class="hs-comment">-- Helpers</span><span>
</span><span id="line-78"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-79"></span><span>
</span><span id="line-80"></span><span class="annot"><a href="Exercises.RandomizeSentence.html#randomSentenceType"><span class="hs-identifier hs-type">randomSentenceType</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-81"></span><span id="randomSentenceType"><span class="annot"><span class="annottext">randomSentenceType :: Int -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.RandomizeSentence.html#randomSentenceType"><span class="hs-identifier hs-var hs-var">randomSentenceType</span></a></span></span><span> </span><span id="local-6989586621679082887"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082887"><span class="hs-identifier hs-var">n</span></a></span></span><span> </span><span id="local-6989586621679082886"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082886"><span class="hs-identifier hs-var">proto</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679082886"><span class="hs-identifier hs-var">proto</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">sentType :: SentenceType
</span><a href="Syntax.ProtoSentence.html#sentType"><span class="hs-identifier hs-var">sentType</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">SentenceType
</span><a href="#local-6989586621679082884"><span class="hs-identifier hs-var">t</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">negated :: Bool
</span><a href="Syntax.ProtoSentence.html#negated"><span class="hs-identifier hs-var">negated</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679082882"><span class="hs-identifier hs-var">b</span></a></span><span class="hs-special">}</span><span>
</span><span id="line-82"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-83"></span><span>    </span><span class="hs-special">(</span><span id="local-6989586621679082884"><span class="annot"><span class="annottext">SentenceType
</span><a href="#local-6989586621679082884"><span class="hs-identifier hs-var">t</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082882"><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679082882"><span class="hs-identifier hs-var">b</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[(SentenceType, Bool)]
</span><a href="Exercises.RandomizeSentence.html#sentOptions"><span class="hs-identifier hs-var">sentOptions</span></a></span><span> </span><span class="annot"><span class="annottext">[(SentenceType, Bool)] -&gt; Int -&gt; (SentenceType, Bool)
forall a. [a] -&gt; Int -&gt; a
</span><span class="hs-operator hs-var">!!</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679082887"><span class="hs-identifier hs-var">n</span></a></span><span> </span><span class="annot"><span class="annottext">Int -&gt; Int -&gt; Int
forall a. Integral a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">`mod`</span></span><span> </span><span class="annot"><span class="annottext">[(SentenceType, Bool)] -&gt; Int
forall (t :: * -&gt; *) a. Foldable t =&gt; t a -&gt; Int
</span><span class="hs-identifier hs-var">length</span></span><span> </span><span class="annot"><span class="annottext">[(SentenceType, Bool)]
</span><a href="Exercises.RandomizeSentence.html#sentOptions"><span class="hs-identifier hs-var">sentOptions</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-84"></span><span>
</span><span id="line-85"></span><span class="hs-comment">-- We want most sentences to be declarative and non negative</span><span>
</span><span id="line-86"></span><span id="sentenceTypes"><span class="annot"><span class="annottext">sentenceTypes :: [SentenceType]
</span><a href="Exercises.RandomizeSentence.html#sentenceTypes"><span class="hs-identifier hs-var hs-var">sentenceTypes</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">SentenceType
</span><a href="Features.Sentential.html#Declarative"><span class="hs-identifier hs-var">Declarative</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">SentenceType
</span><a href="Features.Sentential.html#Declarative"><span class="hs-identifier hs-var">Declarative</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">SentenceType
</span><a href="Features.Sentential.html#YesNoInterrogative"><span class="hs-identifier hs-var">YesNoInterrogative</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-87"></span><span>
</span><span id="line-88"></span><span id="negatedOrNot"><span class="annot"><span class="annottext">negatedOrNot :: [Bool]
</span><a href="Exercises.RandomizeSentence.html#negatedOrNot"><span class="hs-identifier hs-var hs-var">negatedOrNot</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">False</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">False</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">True</span></span><span class="hs-special">]</span><span>
</span><span id="line-89"></span><span>
</span><span id="line-90"></span><span id="sentOptions"><span class="annot"><span class="annottext">sentOptions :: [(SentenceType, Bool)]
</span><a href="Exercises.RandomizeSentence.html#sentOptions"><span class="hs-identifier hs-var hs-var">sentOptions</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="hs-special">(</span><span class="annot"><span class="annottext">SentenceType
</span><a href="#local-6989586621679082876"><span class="hs-identifier hs-var">s</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679082875"><span class="hs-identifier hs-var">n</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">|</span><span> </span><span id="local-6989586621679082876"><span class="annot"><span class="annottext">SentenceType
</span><a href="#local-6989586621679082876"><span class="hs-identifier hs-var">s</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">[SentenceType]
</span><a href="Exercises.RandomizeSentence.html#sentenceTypes"><span class="hs-identifier hs-var">sentenceTypes</span></a></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082875"><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679082875"><span class="hs-identifier hs-var">n</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">[Bool]
</span><a href="Exercises.RandomizeSentence.html#negatedOrNot"><span class="hs-identifier hs-var">negatedOrNot</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-91"></span><span>
</span><span id="line-92"></span><span id="personNumberOptions"><span class="annot"><span class="annottext">personNumberOptions :: [(Person, Number)]
</span><a href="Exercises.RandomizeSentence.html#personNumberOptions"><span class="hs-identifier hs-var hs-var">personNumberOptions</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-93"></span><span>  </span><span class="hs-special">[</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679082874"><span class="hs-identifier hs-var">p</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679082873"><span class="hs-identifier hs-var">n</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-94"></span><span>    </span><span class="hs-glyph">|</span><span> </span><span id="local-6989586621679082874"><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679082874"><span class="hs-identifier hs-var">p</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#First"><span class="hs-identifier hs-var">First</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Second"><span class="hs-identifier hs-var">Second</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Third"><span class="hs-identifier hs-var">Third</span></a></span><span class="hs-special">]</span><span class="hs-special">,</span><span>
</span><span id="line-95"></span><span>      </span><span id="local-6989586621679082873"><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679082873"><span class="hs-identifier hs-var">n</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Plural"><span class="hs-identifier hs-var">Plural</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-96"></span><span>  </span><span class="hs-special">]</span><span>
</span><span id="line-97"></span><span>
</span><span id="line-98"></span><span id="personNumberOptionsThirdSingBias"><span class="annot"><span class="annottext">personNumberOptionsThirdSingBias :: [(Person, Number)]
</span><a href="Exercises.RandomizeSentence.html#personNumberOptionsThirdSingBias"><span class="hs-identifier hs-var hs-var">personNumberOptionsThirdSingBias</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Int -&gt; (Person, Number) -&gt; [(Person, Number)]
forall a. Int -&gt; a -&gt; [a]
</span><span class="hs-identifier hs-var">replicate</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">2</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Third"><span class="hs-identifier hs-var">Third</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">[(Person, Number)] -&gt; [(Person, Number)] -&gt; [(Person, Number)]
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">[(Person, Number)]
</span><a href="Exercises.RandomizeSentence.html#personNumberOptions"><span class="hs-identifier hs-var">personNumberOptions</span></a></span><span>
</span><span id="line-99"></span><span>
</span><span id="line-100"></span><span id="determinerOptions"><span class="annot"><span class="annottext">determinerOptions :: [Determiner]
</span><a href="Exercises.RandomizeSentence.html#determinerOptions"><span class="hs-identifier hs-var hs-var">determinerOptions</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Determiner
</span><a href="Features.Nominal.html#Definite"><span class="hs-identifier hs-var">Definite</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Determiner
</span><a href="Features.Nominal.html#Indefinite"><span class="hs-identifier hs-var">Indefinite</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Distance -&gt; Determiner
</span><a href="Features.Nominal.html#Dem"><span class="hs-identifier hs-var">Dem</span></a></span><span> </span><span class="annot"><span class="annottext">Distance
</span><a href="Features.Adverbial.html#Close"><span class="hs-identifier hs-var">Close</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Distance -&gt; Determiner
</span><a href="Features.Nominal.html#Dem"><span class="hs-identifier hs-var">Dem</span></a></span><span> </span><span class="annot"><span class="annottext">Distance
</span><a href="Features.Adverbial.html#Medium"><span class="hs-identifier hs-var">Medium</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Distance -&gt; Determiner
</span><a href="Features.Nominal.html#Dem"><span class="hs-identifier hs-var">Dem</span></a></span><span> </span><span class="annot"><span class="annottext">Distance
</span><a href="Features.Adverbial.html#Far"><span class="hs-identifier hs-var">Far</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-101"></span><span>
</span><span id="line-102"></span><span id="determinerDegreeOptions"><span class="annot"><span class="annottext">determinerDegreeOptions :: [Distance]
</span><a href="Exercises.RandomizeSentence.html#determinerDegreeOptions"><span class="hs-identifier hs-var hs-var">determinerDegreeOptions</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Distance
</span><a href="Features.Adverbial.html#Close"><span class="hs-identifier hs-var">Close</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Distance
</span><a href="Features.Adverbial.html#Medium"><span class="hs-identifier hs-var">Medium</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Distance
</span><a href="Features.Adverbial.html#Far"><span class="hs-identifier hs-var">Far</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-103"></span></pre></body></html>